<?php

/**

 *

 * Product controller

 *

 * @package	VirtueMart

 * @subpackage

 * @author RolandD

 * @link http://www.virtuemart.net

 * @copyright Copyright (c) 2004 - 2010 VirtueMart Team. All rights reserved.

 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php

 * VirtueMart is free software. This version may have been modified pursuant

 * to the GNU General Public License, and as distributed it includes or

 * is derivative of works licensed under the GNU General Public License or

 * other free or open source software licenses.

 * @version $Id: product.php 6521 2012-10-09 14:49:30Z alatak $

 */



// Check to ensure this file is included in Joomla!

defined('_JEXEC') or die('Restricted access');



if(!class_exists('VmController'))require(JPATH_VM_ADMINISTRATOR.DS.'helpers'.DS.'vmcontroller.php');





/**

 * Product Controller

 *

 * @package    VirtueMart

 * @author

 */

class VirtuemartControllerProduct extends VmController {



	/**

	 * Method to display the view

	 *

	 * @access	public

	 * @author

	 */

	function __construct() {

		parent::__construct('virtuemart_product_id');

		$this->addViewPath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_virtuemart' . DS . 'views');

	}





	/**

	 * Shows the product add/edit screen

	 */

	public function edit($layout='edit') {

		parent::edit('product_edit');

	}



	/**

	 * We want to allow html so we need to overwrite some request data

	 *

	 * @author Max Milbers

	 */

	function save($data = 0){



		$data = JRequest::get('post');



		if(!class_exists('Permissions')) require(JPATH_VM_ADMINISTRATOR.DS.'helpers'.DS.'permissions.php');

		if(Permissions::getInstance()->check('admin')){

			$data['product_desc'] = JRequest::getVar('product_desc','','post','STRING',2);

			$data['product_s_desc'] = JRequest::getVar('product_s_desc','','post','STRING',2);

		} else  {

			$data['product_desc'] = JRequest::getVar('product_desc','','post','STRING',2);

			$data['product_desc'] = JComponentHelper::filterText($data['product_desc']);

			$multix = Vmconfig::get('multix','none');

			if( $multix != 'none' ){

				unset($data['published']);

				unset($data['childs']);

			}



		}

		parent::save($data);

	}



	function saveJS(){

		$data = JRequest::get('get');

		JRequest::setVar($data['token'], '1', 'post');



		JRequest::checkToken() or jexit( 'Invalid Token save' );

		$model = VmModel::getModel($this->_cname);

		$id = $model->store($data);



		$errors = $model->getErrors();

		if(empty($errors)) {

			$msg = JText::sprintf('COM_VIRTUEMART_STRING_SAVED',$this->mainLangKey);

			$type = 'save';

		}

		else $type = 'error';

		foreach($errors as $error){

			$msg = ($error).'<br />';

		}

		$json['msg'] = $msg;

		if ($id) {

			$json['product_id'] = $id;



			$json['ok'] = 1 ;

		} else {

			$json['ok'] = 0 ;



		}

		echo json_encode($json);

		jExit();



	}



	/**

	 * This task creates a child by a given product id

	 *

	 * @author Max Milbers

	 */

	public function createChild(){

		$app = Jfactory::getApplication();



		/* Load the view object */

		$view = $this->getView('product', 'html');



		$model = VmModel::getModel('product');



		//$cids = JRequest::getVar('cid');

		$cids = JRequest::getVar($this->_cidName, JRequest::getVar('virtuemart_product_id',array(),'', 'ARRAY'), '', 'ARRAY');

		//jimport( 'joomla.utilities.arrayhelper' );

		JArrayHelper::toInteger($cids);



		foreach($cids as $cid){

			if ($id=$model->createChild($cid)){

				$msg = JText::_('COM_VIRTUEMART_PRODUCT_CHILD_CREATED_SUCCESSFULLY');

				$redirect = 'index.php?option=com_virtuemart&view=product&task=edit&product_parent_id='.$cids[0].'&virtuemart_product_id='.$id;

			} else {

				$msg = JText::_('COM_VIRTUEMART_PRODUCT_NO_CHILD_CREATED_SUCCESSFULLY');

				$msgtype = 'error';

				$redirect = 'index.php?option=com_virtuemart&view=product';

			}

		}

		$app->redirect($redirect, $msg, $msgtype);



	}



	/**

	* This task creates a child by a given product id

	*

	* @author Max Milbers

	*/

	public function createVariant(){



		$data = JRequest::get('get');

		JRequest::setVar($data['token'], '1', 'post');

		JRequest::checkToken() or jexit('Invalid Token, in ' . JRequest::getWord('task'));



		$app = Jfactory::getApplication();



		/* Load the view object */

		$view = $this->getView('product', 'html');



		$model = VmModel::getModel('product');



		//$cids = JRequest::getVar('cid');

		$cid = JRequest::getInt('virtuemart_product_id',0);



		if(empty($cid)){

			$msg = JText::_('COM_VIRTUEMART_PRODUCT_NO_CHILD_CREATED_SUCCESSFULLY');

// 			$redirect = 'index.php?option=com_virtuemart&view=product&task=edit&virtuemart_product_id='.$cid;

		} else {

			if ($id=$model->createChild($cid)){

				$msg = JText::_('COM_VIRTUEMART_PRODUCT_CHILD_CREATED_SUCCESSFULLY');

				$redirect = 'index.php?option=com_virtuemart&view=product&task=edit&virtuemart_product_id='.$cid;

			} else {

				$msg = JText::_('COM_VIRTUEMART_PRODUCT_NO_CHILD_CREATED_SUCCESSFULLY');

				$msgtype = 'error';

				$redirect = 'index.php?option=com_virtuemart&view=product';

			}

// 			vmdebug('$redirect '.$redirect);

			$app->redirect($redirect, $msg, $msgtype);

		}



	}



	public function massxref_sgrps(){



		$this->massxref('massxref');

	}



	public function massxref_sgrps_exe(){



		$virtuemart_shoppergroup_ids = JRequest::getVar('virtuemart_shoppergroup_id',array(),'', 'ARRAY');

		JArrayHelper::toInteger($virtuemart_shoppergroup_ids);



		$session = JFactory::getSession();

		$cids = unserialize($session->get('vm_product_ids', array(), 'vm'));



		$productModel = VmModel::getModel('product');

		foreach($cids as $cid){

			$data = array('virtuemart_product_id' => $cid, 'virtuemart_shoppergroup_id' => $virtuemart_shoppergroup_ids);

			$data = $productModel->updateXrefAndChildTables ($data, 'product_shoppergroups');

		}



		$this->massxref('massxref_sgrps');

	}



	public function massxref_cats(){

		$this->massxref('massxref');

	}



	public function massxref_cats_exe(){



		$virtuemart_cat_ids = JRequest::getVar('cid',array(),'', 'ARRAY');

		JArrayHelper::toInteger($virtuemart_cat_ids);



		$session = JFactory::getSession();

		$cids = unserialize($session->get('vm_product_ids', array(), 'vm'));



		$productModel = VmModel::getModel('product');

		foreach($cids as $cid){

			$data = array('virtuemart_product_id' => $cid, 'virtuemart_category_id' => $virtuemart_cat_ids);

			$data = $productModel->updateXrefAndChildTables ($data, 'product_categories',TRUE);

		}



		$this->massxref('massxref_cats');

	}



	/**

	 *

	 */

	public function massxref($layoutName){



		JRequest::checkToken() or jexit('Invalid Token, in ' . JRequest::getWord('task'));



		$cids = JRequest::getVar('virtuemart_product_id',array(),'', 'ARRAY');

		JArrayHelper::toInteger($cids);

		if(empty($cids)){

			$session = JFactory::getSession();

			$cids = unserialize($session->get('vm_product_ids', '', 'vm'));

		} else {

			$session = JFactory::getSession();

			$session->set('vm_product_ids', serialize($cids),'vm');

		}



		if(!empty($cids)){

			$q = 'SELECT `product_name` FROM `#__virtuemart_products_' . VMLANG . '` ';

			$q .= ' WHERE `virtuemart_product_id` IN (' . implode(',', $cids) . ')';



			$db = JFactory::getDbo();

			$db->setQuery($q);



			$productNames = $db->loadResultArray();



			vmInfo('COM_VIRTUEMART_PRODUCT_XREF_NAMES',implode(', ',$productNames));

		}



		$this->addViewPath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_virtuemart' . DS . 'views');

		$document = JFactory::getDocument();

		$viewType = $document->getType();

		$view = $this->getView($this->_cname, $viewType);



		$view->setLayout($layoutName);



		$this->display();

	}



	/**

	 * Clone a product

	 *

	 * @author RolandD, Max Milbers

	 */

	public function CloneProduct() {

		$mainframe = Jfactory::getApplication();



		/* Load the view object */

		$view = $this->getView('product', 'html');



		$model = VmModel::getModel('product');

		$msgtype = '';

		//$cids = JRequest::getInt('virtuemart_product_id',0);

		$cids = JRequest::getVar($this->_cidName, JRequest::getVar('virtuemart_product_id',array(),'', 'ARRAY'), '', 'ARRAY');

		//jimport( 'joomla.utilities.arrayhelper' );

		JArrayHelper::toInteger($cids);



		foreach($cids as $cid){

			if ($model->createClone($cid)) {

				$msg = JText::_('COM_VIRTUEMART_PRODUCT_CLONED_SUCCESSFULLY');

			} else {

				$msg = JText::_('COM_VIRTUEMART_PRODUCT_NOT_CLONED_SUCCESSFULLY');

				$msgtype = 'error';

			}

		}



		$mainframe->redirect('index.php?option=com_virtuemart&view=product', $msg, $msgtype);

	}





	/**

	 * Get a list of related products, categories

	 * or customfields

	 * @author RolandD

	 * Kohl Patrick

	 */

	public function getData() {



		/* Create the view object. */

		$view = $this->getView('product', 'json');



		/* Now display the view. */

		$view->display(NULL);

	}



	/**

	 * Add a product rating

	 * @author RolandD

	 */

	public function addRating() {

		$mainframe = Jfactory::getApplication();



		/* Get the product ID */

		// 		$cids = array();

		$cids = JRequest::getVar($this->_cidName, JRequest::getVar('virtuemart_product_id',array(),'', 'ARRAY'), '', 'ARRAY');

		jimport( 'joomla.utilities.arrayhelper' );

		JArrayHelper::toInteger($cids);

		// 		if (!is_array($cids)) $cids = array($cids);



		$mainframe->redirect('index.php?option=com_virtuemart&view=ratings&task=add&virtuemart_product_id='.$cids[0]);

	}





	public function ajax_notifyUsers(){



		//vmdebug('updatestatus');

		

		$virtuemart_product_id = (int)JRequest::getVar('virtuemart_product_id', 0);

		$subject = JRequest::getVar('subject', '');

		$mailbody = JRequest::getVar('mailbody',  '');

		$max_number = (int)JRequest::getVar('max_number', '');

		

		$waitinglist = VmModel::getModel('Waitinglist');

		$waitinglist->notifyList($virtuemart_product_id,$subject,$mailbody,$max_number);

		exit;

	}

	

	public function ajax_waitinglist() {

		

		$virtuemart_product_id = (int)JRequest::getVar('virtuemart_product_id', 0);



		$waitinglistmodel = VmModel::getModel('waitinglist');

		$waitinglist = $waitinglistmodel->getWaitingusers($virtuemart_product_id);



		if(empty($waitinglist)) $waitinglist = array();

		

		echo json_encode($waitinglist);

		exit;



		/*

		$result = array();

		foreach($waitinglist as $wait) array_push($result,array("virtuemart_user_id"=>$wait->virtuemart_user_id,"notify_email"=>$wait->notify_email,'name'=>$wait->name,'username'=>$wait->username));

		

		echo json_encode($result);

		exit;

		*/

	}





}

// pure php no closing tag

