(function($){

    $.fn.validationEngineLanguage = function(){

    };

    $.validationEngineLanguage = {

        newLang: function(){

            $.validationEngineLanguage.allRules = {

                "required": { // Add your regex rules here, you can take telephone as an example

                    "regex": "none",

                    "alertText": "* Pole wymagane",

                    "alertTextCheckboxMultiple": "* Proszę wybrać opcję",

                    "alertTextCheckboxe": "* Pole wymagane"

                },

                "minSize": {

                    "regex": "none",

                    "alertText": "* Minimalna liczba znaków to ",

                    "alertText2": ""

                },

                "maxSize": {

                    "regex": "none",

                    "alertText": "* Maksymalna liczba znaków to ",

                    "alertText2": ""

                },

                "min": {

                    "regex": "none",

                    "alertText": "* Najmniejsza wartość to "

                },

                "max": {

                    "regex": "none",

                    "alertText": "* Największa wartość to "

                },

                "past": {

                    "regex": "none",

                    "alertText": "* Data musi być wcześniejsza niż "

                },

                "future": {

                    "regex": "none",

                    "alertText": "* Data musi być późniejsza niż "

                },	

                "maxCheckbox": {

                    "regex": "none",

                    "alertText": "* Przekroczona maksymalna liczba opcji"

                },

                "minCheckbox": {

                    "regex": "none",

                    "alertText": "* Minimalna liczba opcji to ",

                    "alertText2": ""

                },

                "equals": {

                    "regex": "none",

                    "alertText": "* Pola nie są jednakowe"

                },

                "phone": {

                    // credit: jquery.h5validate.js / orefalo

                    "regex": /^([\+][0-9]{1,3}[ \.\-])?([\(]{1}[0-9]{2,6}[\)])?([0-9 \.\-\/]{3,20})((x|ext|extension)[ ]?[0-9]{1,4})?$/,

                    "alertText": "* Nieprawidłowy numer telefonu"

                },

                "email": {

                    // Shamelessly lifted from Scott Gonzalez via the Bassistance Validation plugin http://projects.scottsplayground.com/email_address_validation/

                    "regex": /^((([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+(\.([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+)*)|((\x22)((((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(([\x01-\x08\x0b\x0c\x0e-\x1f\x7f]|\x21|[\x23-\x5b]|[\x5d-\x7e]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(\\([\x01-\x09\x0b\x0c\x0d-\x7f]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))))*(((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(\x22)))@((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.?$/i,

                    "alertText": "* Nieprawidłowy adres e-mail"

                },

                "integer": {

                    "regex": /^[\-\+]?\d+$/,

                    "alertText": "* Nieprawidłowa liczba całkowita"

                },

                "number": {

                    // Number, including positive, negative, and floating decimal. credit: orefalo

                    "regex": /^[\-\+]?(([0-9]+)([\.,]([0-9]+))?|([\.,]([0-9]+))?)$/,

                    "alertText": "* Nieprawidłowa liczba dziesiętna"

                },

                "CZdate": {

                    // Date in Polish format, regex taken from Czech translation

                    "regex": /^(0[1-9]|[12][0-9]|3[01])[. /.](0[1-9]|1[012])[. /.](19|20)\d{2}$/,

                    "alertText": "* Data musi być w postaci DD.MM.RRRR"

                },

                "date": {

                    "regex": /^\d{4}[\/\-](0?[1-9]|1[012])[\/\-](0?[1-9]|[12][0-9]|3[01])$/,

                    "alertText": "* Data musi być w postaci RRRR-MM-DD"

                },

                "ipv4": {

                    "regex": /^((([01]?[0-9]{1,2})|(2[0-4][0-9])|(25[0-5]))[.]){3}(([0-1]?[0-9]{1,2})|(2[0-4][0-9])|(25[0-5]))$/,

                    "alertText": "* Nieprawidłowy adres IP"

                },

                "url": {

                    "regex": /^(https?|ftp):\/\/(((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:)*@)?(((\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5]))|((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.?)(:\d*)?)(\/((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)+(\/(([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)*)*)?)?(\?((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)|[\uE000-\uF8FF]|\/|\?)*)?(\#((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)|\/|\?)*)?$/,

                    "alertText": "* Nieprawidłowy adres internetowy"

                },

                "onlyNumberSp": {

                    "regex": /^[0-9\ ]+$/,

                    "alertText": "* Tylko liczby"

                },

                "onlyLetterSp": {

                    "regex": /^[a-zA-Z\ \']+$/,

                    "alertText": "* Tylko litery"

                },

                "onlyLetterNumber": {

                    "regex": /^[0-9a-zA-Z]+$/,

                    "alertText": "* Tylko litery i liczby"

                },

                // --- CUSTOM RULES -- Those are specific to the demos, they can be removed or changed to your likings

                "ajaxUserCall": {

                    "url": "ajaxValidateFieldUser",

                    // you may want to pass extra data on the ajax call

                    "extraData": "name=eric",

                    "alertText": "* Nazwa użytkownika jest już zajęta",

                    "alertTextLoad": "* Walidacja, proszę czekać"

                },

                "ajaxNameCall": {

                    // remote json service location

                    "url": "ajaxValidateFieldName",

                    // error

                    "alertText": "* Nazwa jest już zajęta",

                    // if you provide an "alertTextOk", it will show as a green prompt when the field validates

                    "alertTextOk": "* Nazwa jest dostępna",

                    // speaks by itself

                    "alertTextLoad": "* Walidacja, proszę czekać"

                },

                "validate2fields": {

                    "alertText": "* Proszę wpisać HELLO"

                }

            };

            

        }

    };

    $.validationEngineLanguage.newLang();

})(jQuery);

