<?php
/**
 *
 * Show the product details page
 *
 * @package	VirtueMart
 * @subpackage
 * @author Max Milbers, Valerie Isaksen

 * @link http://www.virtuemart.net
 * @copyright Copyright (c) 2004 - 2010 VirtueMart Team. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 * VirtueMart is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * @version $Id: default_images.php 6188 2012-06-29 09:38:30Z Milbo $
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');
vmJsApi::js( 'fancybox/jquery.fancybox-1.3.4.pack');
vmJsApi::css('jquery.fancybox-1.3.4');
$document = JFactory::getDocument ();
$imageJS = '
jQuery(document).ready(function() {
	jQuery("a[rel=vm-additional-images]").fancybox({
		"titlePosition" 	: "inside",
		"transitionIn"	:	"elastic",
		"transitionOut"	:	"elastic"
	});
});
';
$document->addScriptDeclaration ($imageJS);

if (!empty($this->product->images)) {
	// $image = $this->product->images[0];
	$i = 0;
	?>
	<div id="product_img_<?php echo $this->product->virtuemart_product_id; ?>">
		<div class="main-image">
			<div class="tab-content">
				<?php foreach($this->product->images as $image) { 
					$i++; ?>
					<div id="tab_<?php echo $i; ?>" class="tab-pane<?php echo $i==1?' active':''; ?>">
						<?php
							// echo $image->displayMediaFull("",true,"rel='vm-additional-images'");
							echo $image->displayMediaThumb("",true,"rel='vm-additional-images'");
						?>
					</div>
				<?php } ?>
			</div>
			<div class="clear"></div>
		</div>
		<?php $count_images = count ($this->product->images);
		if ($count_images > 1) {
			?>
			<div id="add_img_<?php echo $this->product->virtuemart_product_id; ?>" class="additional-images">
				<!-- <ul class="nav">
					<?php
					for ($i = 0; $i < $count_images; $i++) {
						$image = $this->product->images[$i];
						?>
						<li class="<?php echo $i==0?'active':''; ?>">
							<a href="#tab_<?php echo $i+1; ?>" data-toggle="tab">
								<img src="<?php echo JURI::root().$image->file_url_thumb; ?>" alt="thumb" />
							<?php
								// echo $image->displayMediaFull("",true,"rel='vm-additional-images'");
							?>
							</a>
						</li>
						<?php
					}
					?>
				</ul> -->
				<div class="carousel slide">
					<div class="carousel-inner">
						<ul class="nav item active">
							<?php foreach($this->product->images as $key=>$image) { ?>
								<li class="span4<?php echo $key==0?' active':''; ?>">
									<a href="#tab_<?php echo $key+1; ?>" data-toggle="tab">
										<img src="<?php echo JURI::root().$image->file_url_thumb; ?>" alt="thumb" />
									<?php
										// echo $image->displayMediaFull("",true,"rel='vm-additional-images'");
									?>
									</a>
								</li>
								<?php if (($key+1)%3==0 and ($key+1) < $count_images){
									echo '</ul><ul class="nav item">';
								} ?>
							<?php } ?>
						</ul>
					</div>
					<!-- "previous page" action -->
					<a class="carousel-control control-square control-light left" href="#add_img_<?php echo $this->product->virtuemart_product_id; ?>" data-slide="prev"><span class="icon-prev-bold"></span></a>
					<!-- "next page" action -->
					<a class="carousel-control control-square control-light right" href="#add_img_<?php echo $this->product->virtuemart_product_id; ?>" data-slide="next"><span class="icon-next-bold"></span></a>
				</div>
				<div class="clear"></div>
			</div>
			
			<script type="text/javascript">
			
				jQuery.noConflict();
				jQuery(document).ready(function($) {
					// $("#product_img_<?php echo $this->product->virtuemart_product_id; ?> .additional-images").mCustomScrollbar({
						// scrollInertia:800,
						// horizontalScroll: true,
						// scrollButtons:{
							// enable:true,
							// scrollSpeed: 800
						// },
						// advanced:{
							// autoExpandHorizontalScroll:true
						// },
						// theme:"dark"
					// });
					$('#add_img_<?php echo $this->product->virtuemart_product_id; ?>').carousel("pause");
				});
			
			</script>
		<?php } ?>
	</div>
<?php }
  // Showing The Additional Images END ?>