<?php
/**
 *
 * Show the product details page
 *
 * @package	VirtueMart
 * @subpackage
 * @author Max Milbers, Valerie Isaksen

 * @link http://www.virtuemart.net
 * @copyright Copyright (c) 2004 - 2010 VirtueMart Team. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 * VirtueMart is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * @version $Id: default_relatedproducts.php 6431 2012-09-12 12:31:31Z alatak $
 */

// Check to ensure this file is included in Joomla!
defined ( '_JEXEC' ) or die ( 'Restricted access' );
$Browsecellwidth = ' span' . floor (OGRID_SYS / VmConfig::get ( 'products_per_row', 3 ));
$iBrowseCol = 1;
$iBrowseProduct = 1;
?>
        <div class="product-related-products">
			<h4><?php echo JText::_('COM_VIRTUEMART_RELATED_PRODUCTS'); ?></h4>
			<div id="related-products" class="vmgroup carousel slide">
				<?php if(count($this->product->customfieldsRelatedProducts)>VmConfig::get ( 'products_per_row', 3 )){ ?>
					<div class="ot-slidenav">
						<!-- "previous page" action -->
						<a class="carousel-control control-square left" href="#related-products" data-slide="prev"><span class="icon-prev"></span></a>
						<!-- "next page" action -->
						<a class="carousel-control control-square right" href="#related-products" data-slide="next"><span class="icon-next"></span></a>
					</div>
				<?php } ?>
				<div class="carousel-inner">
					<div class="ot-vmproduct item active">
						<?php
						$product_model = VmModel::getModel('product');
						foreach ($this->product->customfieldsRelatedProducts as $key => $field) {
							$product = $product_model->getProduct($field->custom_value);
							$product_model->addImages($product);
						?>
							<!--<div class="product-field product-field-type-<?php echo $field->field_type ?>">
								<span class="product-field-display"><?php echo $field->display ?></span>
							</div>-->
							<div class="product<?php echo $Browsecellwidth ?>">
								<div class="spacer">
									<div class="product-image center">
										<?php $image = explode('>', $field->display);
										$image = $image[1].'>';
										echo JHTML::_('link', JRoute::_('index.php?option=com_virtuemart&view=productdetails&virtuemart_product_id='.$product->virtuemart_product_id.'&virtuemart_category_id='.$product->virtuemart_category_id),$image,array('title' => $product->product_name) );?>
										<?php if (!empty($product->prices['discountAmount'])&&!empty($product->prices['basePriceWithTax'])) { ?>
											<span class="product-discount"><?php echo JText::_('TPL_OT_SALEOFF'); ?></span>
										<?php } ?>
									</div>
									<div class="clear"></div>
									<div class="product-detail">
										<div class="product-detail-i">
											<div class="product-name">
												<?php echo JHTML::link($product->link, $product->product_name); ?>
											</div>
											<div class="clear"></div>
											<p class="product_s_desc">
												<?php echo shopFunctionsF::limitStringByWord($product->product_s_desc, 70, '...');?>
											</p>
											<div class="clear"></div>
											<?php $maxrating = VmConfig::get('vm_maximum_rating_scale',5);
											$ratingModel = VmModel::getModel('ratings');
											$showRating = $ratingModel->showRating();
											if ($showRating) { ?>
												<div class="vote floatleft">
													<?php $rating = $ratingModel->getRatingByProduct($product->virtuemart_product_id);
													if (empty($rating)) { ?>
														<span class="vote"><?php echo JText::_('COM_VIRTUEMART_UNRATED') ?></span>
													<?php } else {
														// $ratingwidth = ( $rating->rating * 100 ) / $maxrating;
														$ratingwidth = $rating->rating * 14;//I don't use round as percetntage with works perfect, as for me
														?>
														<span class="vote">
															<span title=" <?php echo (JText::_("COM_VIRTUEMART_RATING_TITLE") . $rating->rating . '/' . $maxrating) ?>" class="vmicon ratingbox" style="display:inline-block;">
																<!-- <span class="stars-orange" style="width:<?php echo $ratingwidth;?>%"> -->
																<span class="stars-orange" style="width:<?php echo $ratingwidth;?>px">
																</span>
															</span>
														</span>
														<?php
													} ?>
												</div>
											<?php } ?>
											<div class="product-rel-price floatright" id="productPrice<?php echo $product->virtuemart_product_id ?>">
												<?php if (isset($product->prices)){
													if (round($product->prices['basePriceWithTax'],$this->currency->_priceConfig['salesPrice'][1]) != $product->prices['salesPrice']) {
														echo '<div class="price-crossed" >' . $this->currency->createPriceDiv ('basePriceWithTax', 'COM_VIRTUEMART_PRODUCT_BASEPRICE_WITHTAX', $product->prices) . "</div>";
													}
													if (round($product->prices['basePriceWithTax'],$this->currency->_priceConfig['salesPrice'][1]) != $product->prices['salesPrice']) {
														echo '<div class="price-new">';
													}
													echo $this->currency->createPriceDiv ('salesPrice', 'COM_VIRTUEMART_PRODUCT_SALESPRICE', $product->prices);
													if (round($product->prices['basePriceWithTax'],$this->currency->_priceConfig['salesPrice'][1]) != $product->prices['salesPrice']) {
														echo '</div>';
													}
												} ?>
											</div>
											<div class="clear"></div>
											<div class="product-addtocart">
												<?php echo JHTML::link($product->link, JText::_('COM_VIRTUEMART_PRODUCT_DETAILS'), array('title' => $product->product_name,'class' => 'product-details')); ?>
											</div>
										</div>
									</div>
								</div>
							</div>
						<?php 
							if ($iBrowseCol == VmConfig::get ( 'products_per_row', 3 ) && VmConfig::get ( 'products_per_row', 3 ) && $iBrowseProduct < count($this->product->customfieldsRelatedProducts)) {
								echo '	</div><div class="ot-vmproduct item">';
								$iBrowseCol = 1;
							} else {
								$iBrowseCol++;
							}
							$iBrowseProduct++;
						} ?>
					</div>
				</div>
			</div>
        </div>
		<script type="text/javascript">
		<!--
			jQuery.noConflict();
			jQuery(document).ready(function($) {
				$('#related-products').carousel();
			});
		-->
		</script>
		<div class="clear"></div>