<?php
/*----------------------------------------------------------------------
 # mod_ot_lightboxlogin - OT Lightbox Login Module For Joomla! 1.7
 #----------------------------------------------------------------------
 # author OmegaTheme.com
 # copyright Copyright(C) 2008 - 2011 OmegaTheme.com. All Rights Reserved.
 # @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 # Website: http://omegatheme.com
 # Technical support: Forum - http://omegatheme.com/forum/
------------------------------------------------------------------------*/

// no direct access
defined('_JEXEC') or die;
JHtml::_('behavior.keepalive');
JHtml::_('behavior.formvalidation');
?>
<?php if ($type == 'logout') : ?>
<form action="<?php echo JRoute::_('index.php', true, $params->get('usesecure')); ?>" method="post" id="ot-logout-form">
	<div class="ot-logout-wrap">
		<?php if ($params->get('greeting')) : ?>
		<span class="ot-greeting">
			<span class="ot-logged-greeting">
				<span class="ot-logged-greeting-inner">
				<?php if($params->get('name') == 0) : {
					echo JText::sprintf('MOD_OTLIGHTBOXLOGIN_HINAME', $user->get('name'));
				} else : {
					echo JText::sprintf('MOD_OTLIGHTBOXLOGIN_HINAME', $user->get('username'));
				} endif; ?>
				</span>
			</span>
		</span>
		<?php endif; ?>
		<?php
			$logoutTitle = JString::trim($params->get('logout_title'));
			if ($logoutTitle == '') {
				$logoutTitle = JText::_('JLOGOUT');
			}
		?>
		<span class="ot-logout-button">
			<span class="ot-logout-button-inner">
				<input type="submit" name="Submit" class="button" value="<?php echo $logoutTitle; ?>" />
			</span>
		</span>
			<input type="hidden" name="option" value="com_users" />
			<input type="hidden" name="task" value="user.logout" />
			<input type="hidden" name="return" value="<?php echo $return; ?>" />
			<?php echo JHtml::_('form.token'); ?>
	</div>
</form>
<div style="clear: both;"></div>
<?php else : ?>
<?php
	$usersConfig = JComponentHelper::getParams('com_users');
?>

<div id="ot-login-popup-wrap">
	<span class="ot-welcome"><?php echo JText::_('TPL_OT_WELCOME'); ?></span>
	<?php
	$loginText = htmlspecialchars(JString::trim($params->get('login_title')));
	$registerText = htmlspecialchars(JString::trim($params->get('register_title')));
	$seperator = htmlspecialchars(JString::trim($params->get('seperator')));
	if ($usersConfig->get('allowUserRegistration')) {
		echo '<a href="#ot-lightbox-wrapper" role="button" id="ot-login-label" data-toggle="modal">'.$loginText.'</a> <span class="seperator">'.$seperator.' </span> <a href="#ot-lightbox-wrapper" role="button" id="ot-signup-label" data-toggle="modal">'.$registerText.'</a>';
	} else {
		echo '<a href="#ot-lightbox-wrapper" role="button" id="ot-login-label" data-toggle="modal">'.$loginText.'</a>';
	}
	?>
</div>
<div style="clear: both;"></div>
<div id="ot-lightbox-wrapper" class="modal hide fade" tabindex="-1" role="dialog" aria-hidden="true">
	<div class="modal-header">
		<button type="button" class="close" data-dismiss="modal" aria-hidden="true"><span class="icon-remove"></span></button>
	</div>
	<div class="modal-body">
		<div class="ot-tabs">
			<ul id="ot-lightbox-tabs" class="nav nav-tabs">
				<li>
					<a id="ot-login-tab" href="#ot-login-content" data-toggle="tab"><?php echo JText::_('JLOGIN') ?></a>
				</li>
				<?php if ($usersConfig->get('allowUserRegistration')): ?>
				<li>
					<a id="ot-signup-tab" href="#ot-signup-content" data-toggle="tab"><?php echo JText::_('JREGISTER') ?></a>
				</li>
				<?php endif; ?>
			</ul>
			<div class="tab-content">
				<div id="ot-login-content" class="tab-pane">
					<form action="<?php echo JRoute::_('index.php', true, $params->get('usesecure')); ?>" method="post" id="ot-login-form" >
						<div class="ot-login-form-custom">
							<div class="userdata">
								<p class="form-login-username">
									<label for="modlgn-username"><?php echo JText::_('MOD_OTLIGHTBOXLOGIN_VALUE_USERNAME') ?></label>
									<input id="modlgn-username" type="text" name="username" class="input-medium"  size="18" />
								</p>
								<p class="form-login-password">
									<label for="modlgn-passwd"><?php echo JText::_('JGLOBAL_PASSWORD') ?></label>
									<input id="modlgn-passwd" type="password" name="password" class="input-medium" size="18"  />
								</p>
								<?php if (JPluginHelper::isEnabled('system', 'remember')) : ?>
								<p class="form-login-remember">
									<input id="modlgn-remember" type="checkbox" name="remember" value="yes"/>
									<label for="modlgn-remember"><?php echo JText::_('MOD_OTLIGHTBOXLOGIN_REMEMBER_ME') ?></label>
								</p>
								<?php endif; ?>
								<p class="ot-submit">
									<input type="submit" name="Submit" class="btn btn-primary" value="<?php echo JText::_('JLOGIN') ?>" />
									<input type="hidden" name="option" value="com_users" />
									<input type="hidden" name="task" value="user.login" />
									<input type="hidden" name="return" value="<?php echo $return; ?>" />
									<?php echo JHtml::_('form.token'); ?>
								</p>
							</div>
							<ul>
								<li>
									<a href="<?php echo JRoute::_('index.php?option=com_users&view=reset'); ?>">
										<?php echo JText::_('MOD_OTLIGHTBOXLOGIN_FORGOT_YOUR_PASSWORD'); ?>
									</a>
								</li>
								<li>
									<a href="<?php echo JRoute::_('index.php?option=com_users&view=remind'); ?>">
										<?php echo JText::_('MOD_OTLIGHTBOXLOGIN_FORGOT_YOUR_USERNAME'); ?>
									</a>
								</li>
							</ul>
						</div>
					</form>
				</div>
				<div id="ot-signup-content" class=" tab-pane">
					<?php
					if ($usersConfig->get('allowUserRegistration')) : ?>
						<div class="ot-registration">
							<form id="ot-member-registration" action="<?php echo JRoute::_('index.php?option=com_users&task=registration.register'); ?>" method="post" class="form-validate">
								<div class="ot-user-signup">
									<p style="margin-top: 0;"><strong class="red">*</strong> <?php echo JText::_('MOD_OTLIGHTBOXLOGIN_REQUIRED'); ?></p>
									<p class="form-signup form-signup-name">
										<label class="required" for="jform_name" id="jform_name-lbl">Name:<span class="star">&nbsp;*</span></label>
										<input type="text" size="30" class="required input-medium" value="" id="jform_name" name="jform[name]" />
									</p>
									<p class="form-signup form-signup-username">
										<label class="required" for="jform_username" id="jform_username-lbl">Username:<span class="star">&nbsp;*</span></label>
										<input type="text" size="30" class="validate-username required input-medium" value="" id="jform_username" name="jform[username]" />
									</p>
									<p class="form-signup form-signup-password">
										<label class="required" for="jform_password1" id="jform_password1-lbl">Password:<span class="star">&nbsp;*</span></label>
										<input type="password" size="30" class="validate-password required input-medium" autocomplete="off" value="" id="jform_password1" name="jform[password1]" />
									</p>
									<p class="form-signup form-signup-confirm-password">
										<label class="required" for="jform_password2" id="jform_password2-lbl">Confirm Password:<span class="star">&nbsp;*</span></label>
										<input type="password" size="30" class="validate-password required input-medium" autocomplete="off" value="" id="jform_password2" name="jform[password2]" />
									</p>
									<p class="form-signup form-signup-email">
										<label class="required" for="jform_email1" id="jform_email1-lbl">Email Address:<span class="star">&nbsp;*</span></label>
										<input type="text" size="30" value="" id="jform_email1" class="validate-email required input-medium" name="jform[email1]" />
									</p>
									<p class="form-signup form-signup-confirm-email">
										<label class="required" for="jform_email2" id="jform_email2-lbl">Confirm email Address:<span class="star">&nbsp;*</span></label>
										<input type="text" size="30" value="" id="jform_email2" class="validate-email required input-medium" name="jform[email2]" />
									</p>
								</div>
								<div>
									<button type="submit" class="validate btn btn-primary"><?php echo JText::_('JREGISTER');?></button>
									<?php echo JText::_('COM_USERS_OR');?>
									<a href="<?php echo JRoute::_('');?>" title="<?php echo JText::_('JCANCEL');?>"><?php echo JText::_('JCANCEL');?></a>
									<input type="hidden" name="option" value="com_users" />
									<input type="hidden" name="task" value="registration.register" />
									<?php echo JHtml::_('form.token');?>
								</div>
							</form>
						</div>
					<?php endif; ?>
				</div>
			</div>
		</div>
	</div>
	<div class="modal-footer">
		<div class="ot-lightbox-br">
			<div class="ot-lightbox-bm">
				<div class="ot-lightbox-login"><?php echo JText::_('ABOUT_OTLIGHTBOXLOGIN'); ?></div>
			</div>
		</div>
	</div>
</div>
<script type="text/javascript">
	<!--
		jQuery.noConflict();
		jQuery(document).ready(function($) {
			$('#ot-login-label').on('click', function (e) {
				$('#ot-login-tab').tab('show');				
			})
			$('#ot-signup-label').on('click', function (e) {
				$('#ot-signup-tab').tab('show');				
			})
		});
	-->
</script>
<?php endif; ?>
